From 33219b9f4dc73699d02462f60bb278f79deb72c9 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sun, 12 Feb 2012 16:28:16 +0100
Subject: [PATCH] mfi(4): Update to LSI's version 4.23 of the driver.

Brings in support for a couple of new cards, namely the Intel RAID
controllers RS25DB080 and RS25NB008. Probably also for other cards
of the "ThunderBolt" type.

A few other things have been fixed too. Most x86_64/i386 specific
parts have been merged, MSI is now setup in mfi_pci.c properly.

Many thanks to LSI for having a place for the BSDs in their heart
and to Xin Li for bringing this work to my attention. It was taken
from FreeBSD's projects/ repository.

The ThunderBolt support has not been tested yet since I don't own
a compatible card.
---
 share/man/man4/mfi.4         |    6 +-
 sys/conf/files               |    1 +
 sys/dev/raid/mfi/Makefile    |    2 +-
 sys/dev/raid/mfi/mfi.c       | 1048 +++++++++++++++++++++-----------
 sys/dev/raid/mfi/mfi_cam.c   |   35 +-
 sys/dev/raid/mfi/mfi_debug.c |   20 +-
 sys/dev/raid/mfi/mfi_disk.c  |   43 +-
 sys/dev/raid/mfi/mfi_ioctl.h |   41 +-
 sys/dev/raid/mfi/mfi_pci.c   |   84 ++--
 sys/dev/raid/mfi/mfi_syspd.c |   13 +-
 sys/dev/raid/mfi/mfi_tbolt.c | 1383 ++++++++++++++++++++++++++++++++++++++++++
 sys/dev/raid/mfi/mfireg.h    |  634 ++++++++++++++++++--
 sys/dev/raid/mfi/mfivar.h    |  219 ++++++--
 13 files changed, 2933 insertions(+), 596 deletions(-)
 create mode 100644 sys/dev/raid/mfi/mfi_tbolt.c

diff --git a/sys/conf/files b/sys/conf/files
index cf01bf8..f492730 100644
--- a/sys/conf/files
+++ b/sys/conf/files
@@ -578,6 +578,7 @@ dev/raid/mfi/mfi_debug.c	optional mfi
 dev/raid/mfi/mfi_pci.c		optional mfi pci
 dev/raid/mfi/mfi_disk.c		optional mfi
 dev/raid/mfi/mfi_syspd.c	optional mfi
+dev/raid/mfi/mfi_tbolt.c	optional mfi
 dev/raid/mfi/mfi_linux.c	optional mfi compat_linux
 dev/raid/mfi/mfi_cam.c		optional mfip scbus
 dev/netif/mii_layer/mii.c		optional miibus
diff --git a/sys/dev/raid/mfi/Makefile b/sys/dev/raid/mfi/Makefile
index 809eac3..62557da 100644
--- a/sys/dev/raid/mfi/Makefile
+++ b/sys/dev/raid/mfi/Makefile
@@ -8,7 +8,7 @@ SUBDIR+= mfi_linux
 .endif
 
 KMOD=	mfi
-SRCS=	mfi.c mfi_pci.c mfi_disk.c mfi_debug.c mfi_syspd.c
+SRCS=	mfi.c mfi_pci.c mfi_disk.c mfi_debug.c mfi_syspd.c mfi_tbolt.c
 SRCS+=	opt_mfi.h opt_cam.h
 SRCS+=	device_if.h bus_if.h pci_if.h
 
